<template>
  <div class="qr">
    <div class="qr-container">
      <div class="qr-image">
        <img :src="urlQR" alt="Heta Authenticator QR code" v-if="!!urlQR">
      </div>
      <div class="secret_otp">
        <p class="secret">{{ key_2fa }}</p>
        <p class="description">{{ $t('otp.qr.desc') }}</p>
      </div>
    </div>
    <div class="qr-footer btn-group">
      <div class="btn-item">
        <button class="btn-step btn-prev-step" @click="$emit('previous')" type="button"><i class="fa fa-angle-left" aria-hidden="true"></i> {{ $t('otp.btnPrev') }}</button>
      </div>
      <div class="btn-item">
        <button @click="nextStep()" type="button" class="btn-step btn-next-step">{{ $t('otp.btnNext') }} <i class="fa fa-angle-right" aria-hidden="true"></i></button>
      </div>
    </div>
  </div>
</template>

<script>
import { mapMutations } from 'vuex';

import rf from '../../../common/requests/RequestFactory';

export default {
  data() {
    return {
      urlQR : '',
      key_2fa: '',
    }
  },
  methods : {
    ...mapMutations([
      'update2FaSecret',
    ]),
    getQRCodeGoogleUrl() {
      rf.getRequest('UserRequest').getQRCodeGoogleUrl()
        .then(res => {
          this.urlQR = res.data.url;
          this.key_2fa = res.data.key;
          this.update2FaSecret(res.data.key);
        });
    },
    nextStep () {
      if (!this.key_2fa) {
        return;
      }
      this.$emit('next');
    },
  },
  created () {
    this.getQRCodeGoogleUrl();
  }
}
</script>
<style lang="scss" scoped>
  @import '../../../../sass/mobile/app.scss';

  *{
    font-family: $font-family-home;
  }
  .qr {
    margin-top: 13rem;
    .qr-container {
      font-size: 0;
      .qr-image {
        width: 120rem;
        height: 120rem;
        border: solid 1rem #e0e0e0;
        display: inline-block;
        text-align: center;
        vertical-align: top;
        img {
          width: 90rem;
          height: 90rem;
          margin-top: 14rem;
        }
      }
      .secret_otp {
        display: inline-block;
        width: calc(100% - 120rem);
        padding-left: 15rem;
        padding-top: 7rem;

        .secret {
          word-break: break-all;
          font-size: $small;
          font-weight: bold;
          color: #1c1c1c;
          margin: 0;
        }
        .description {
          font-size: $small;
          color: #707070;
          line-height: 1.29;
        }
      }
    }
    .qr-footer {
      font-size: 0;
      position: absolute;
      width: 100%;
      right: 6rem;
      bottom: 0;
    }
  }
</style>
